#include <gd.h>
#include <stdio.h>

int main() {
  gdImagePtr im;
  FILE *pngout;
  int black, white, red;

  im = gdImageCreate(50, 50);

  white = gdImageColorAllocate(im, 255, 255, 255);  
  black = gdImageColorAllocate(im, 0, 0, 0);  
  red = gdImageColorAllocate(im, 255, 0, 0);

  gdImageSetPixel(im, 10, 10, red);
  gdImageFilledEllipse(im, 10, 10, 1, 1, black);

  gdImageFilledRectangle(im, 19,9, 20,10, red);
  gdImageFilledEllipse(im, 20, 10, 2, 2, black);

  gdImageFilledRectangle(im, 29,9, 31,11, red);
  gdImageFilledEllipse(im, 30, 10, 3, 3, black);

  gdImageFilledRectangle(im, 39,8, 42,11, red);
  gdImageFilledEllipse(im, 40, 10, 4, 4, black);

  gdImageFilledRectangle(im, 8,28, 12,32, red);
  gdImageFilledEllipse(im, 10, 30, 5, 5, black);

  gdImageFilledRectangle(im, 18,27, 23,32, red);
  gdImageFilledEllipse(im, 20, 30, 6, 6, black);

  gdImageFilledRectangle(im, 27,27, 33,33, red);
  gdImageFilledEllipse(im, 30, 30, 7, 7, black);

  gdImageFilledRectangle(im, 37,26, 44,33, red);
  gdImageFilledEllipse(im, 40, 30, 8, 8, black);

  pngout = fopen("test.png", "wb");
  gdImagePng(im, pngout);

  fclose(pngout);
  gdImageDestroy(im);
}
